import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.Component;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTree;
import javax.swing.JScrollPane;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.JFileChooser;
import java.io.File;    
import java.util.ArrayList;
import java.util.List;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class aw_test1 {
	
	public class MyTree extends JTree {

		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		
		@Override
	    public String convertValueToText(Object value, boolean selected,
                boolean expanded, boolean leaf, int row,
                boolean hasFocus) {
			
			String sValue; 
			Node xmlnode;
			if(value != null) {
			if (value.getClass().getName() == "javax.swing.tree.DefaultMutableTreeNode") {
			DefaultMutableTreeNode treenode = (DefaultMutableTreeNode) value;
			Object someobj = treenode.getUserObject();
			switch (someobj.getClass().getName()) {
				case "com.sun.org.apache.xerces.internal.dom.DeferredElementImpl": 
					xmlnode = (Node) someobj;
					sValue = xmlnode.getNodeName();break;
				case "com.sun.org.apache.xerces.internal.dom.DeferredTextImpl": 
					xmlnode = (Node) someobj;
					sValue = xmlnode.getNodeValue();break;	
				default: sValue = someobj.toString();
			}	    	  									
				if (sValue != null) {
					return sValue;
				}
			}	
			return "";}			
			return ""; 
			}
		
	    } /* MyTree */

	private JFrame frame;
	private MyTree tree;
	private JTable table;
	private final Action action = new SwingAction();
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					aw_test1 window = new aw_test1();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public aw_test1() {
		initialize();
	}
    
	
	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 343, 448);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		DefaultMutableTreeNode top = new DefaultMutableTreeNode("The Java Series");
		createNodes(top);
		
		/* Tree */ tree = new MyTree();
	    tree.setModel(new DefaultTreeModel(top));
		tree.addMouseListener(new MouseAdapter() {
 	@Override
 	public void mouseClicked(MouseEvent arg0) {
 		DefaultTableModel myData = (DefaultTableModel) table.getModel();
 		myData.setRowCount(0);
 		/* tree.gets */
 	    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                tree.getLastSelectedPathComponent();

 	    if (node == null)
 	    	//Nothing is selected.     
 	    	return;

 	    /* Object nodeInfo = node.getUserObject(); */
 	    Node xmlnode = (Node) node.getUserObject();
 	    if (xmlnode.hasAttributes()) {
 	    	NamedNodeMap attrs = xmlnode.getAttributes();
 	    	for (int i = 0; i < attrs.getLength(); i++) {
 	    		Node crAttr = attrs.item(i);
 	    		myData.addRow(new Object[]{crAttr.getNodeName(), crAttr.getNodeValue()});}
 	    }
 	}
 });
		JScrollPane treeView = new JScrollPane(tree);
		treeView.setBounds(0, 0, 500, 0); /* ??? */
		frame.getContentPane().add(treeView, BorderLayout.WEST);
		
		table = new JTable();
		table.setModel(new DefaultTableModel(
			new Object[][] {
			},
			new String[] {
				"Name", "Value"
			}
		));
		/* frame.getContentPane().add(table.getTableHeader(), BorderLayout.PAGE_START); */
		frame.getContentPane().add(table, BorderLayout.CENTER);
		
		JMenuBar menuBar = new JMenuBar();
		frame.setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmOpen = new JMenuItem("Open");
		mntmOpen.setAction(action);
		mnFile.add(mntmOpen);
	}
	
	private void createNodes(DefaultMutableTreeNode top) {
	    DefaultMutableTreeNode category = null;
	    DefaultMutableTreeNode book = null;
	    
	    category = new DefaultMutableTreeNode("Books for Java Programmers");
	    top.add(category);
	    
	    //original Tutorial
	    book = new DefaultMutableTreeNode("The Java Tutorial: A Short Course on the Basics");
	    category.add(book);
	    
	    //Tutorial Continued
	    book = new DefaultMutableTreeNode("The Java Tutorial Continued: The Rest of the JDK");
	    category.add(book);
	    
	    //Swing Tutorial
	    book = new DefaultMutableTreeNode("The Swing Tutorial: A Guide to Constructing GUIs");
	    category.add(book);

	    //...add more books for programmers...

	    category = new DefaultMutableTreeNode("Books for Java Implementers");
	    top.add(category);

	    //VM
	    book = new DefaultMutableTreeNode("The Java Virtual Machine Specification");
	    category.add(book);

	    //Language Spec
	    book = new DefaultMutableTreeNode("The Java Language Specification");
	    category.add(book);
	}
	
    private static Document getDocument(File sFile) throws Exception {
        try {
            DocumentBuilderFactory f = DocumentBuilderFactory.newInstance();
            f.setValidating(false);
            DocumentBuilder builder = f.newDocumentBuilder();
            return builder.parse(sFile);
        } catch (Exception exception) {
            String message = "XML parsing error!";
            throw new Exception(message);
        }
    }
    
    private static void FillNodes(DefaultMutableTreeNode treenode, Node xmlnode) {
    	/* switch (xmlnode.getNodeType())   	{
    		case Node.ELEMENT_NODE: treenode.setUserObject(xmlnode.getNodeName());break;
    		case Node.TEXT_NODE: treenode.setUserObject(xmlnode.getNodeValue());break;
    	}  */  	
    	treenode.setUserObject(xmlnode);
    	if (xmlnode.hasChildNodes()) {
    		for (int i = 0; i < xmlnode.getChildNodes().getLength(); i++)	{
    			DefaultMutableTreeNode subtreenode;
    			subtreenode = new DefaultMutableTreeNode();
    			FillNodes(subtreenode, xmlnode.getChildNodes().item(i));
    			treenode.add(subtreenode);
    		}
    	}
    }
    
    private DefaultTreeModel FillModel(DefaultTreeModel model, Document doc) {
    	DefaultMutableTreeNode top = (DefaultMutableTreeNode) model.getRoot();
    	top.removeAllChildren();
    	Node node = doc.getDocumentElement();
    	/* top.setUserObject(node.getNodeName()); */
    	FillNodes(top, node);
    	model.nodeChanged(top);
    	/* tree.repaint(); */
    	model.reload(); 
    	return model;
    }

	private class SwingAction extends AbstractAction {
		public SwingAction() {
			putValue(NAME, "SwingAction");
			putValue(SHORT_DESCRIPTION, "Some short description");
		}
		public void actionPerformed(ActionEvent e) {
			JFileChooser fileChooser = new JFileChooser();
			fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
			int result = fileChooser.showOpenDialog(frame);
			if (result == JFileChooser.APPROVE_OPTION) {
			    File selectedFile = fileChooser.getSelectedFile();
			    /* System.out.println("Selected file: " + selectedFile.getAbsolutePath());*/
			    try {
                    Document doc = getDocument(selectedFile);    
                    doc.normalizeDocument();
                    /* Component comp = frame.getContentPane().getComponent(0);
                    if (comp.getClass().getName() == "javax.swing.JScrollPane") {
                    	comp.
                    	/* javax.swing.JTree */
                    	/* JTree tree = (JTree) comp; */
                    	tree.setEditable(true);           
                    	DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
                    	DefaultMutableTreeNode top = (DefaultMutableTreeNode) model.getRoot();
                    	top.removeAllChildren();
                    	Node node = doc.getDocumentElement();
                    	/* top.setUserObject(node.getNodeName()); */ 
                    	FillNodes(top, node);
                    	model.nodeChanged(top);
                    	/* tree.repaint(); */
                    	model.reload(); 
                                        		
                    /* JTree tree = (JTree) frame.getContentPane().getComponent(0);
                    {doc.getLocalName();}
                    /* showDocument(doc, textArea); */
                } catch (Exception ex) {
                    /* JOptionPane.showMessageDialog(frame, ex.getMessage()); */
                }
			}
		}
	}
}
